# Functionals

class tensorrt_llm.functional.AllReduceStrategy(value)

  Bases: `IntEnum`

  Warning: actual definition is in cpp/tensorrt_llm/kernels/customAllReduceKernels.h

    they must be kept in sync

  AUTO = 3
  ONESHOT = 1
  RING = 0
  TWOSHOT = 2

class tensorrt_llm.functional.AttentionMaskType(value)

  Bases: `IntEnum`

  An enumeration.

  bidirectional = 2
  bidirectionalglm = 3
  causal = 1
  padding = 0

class tensorrt_llm.functional.DimRange(shape: List[int | List[int] | Tuple[int, int, int]], names: List[str])

  Bases: `object`

  One DimRange object stores the ranges of all the dimensions of one tensor in one optimization profile. For example, tensor has 2 dimensions. Then the data members are:

  > self.min = [dim 0 min, dim 1 min] self.opt = [dim 0 opt, dim 1 opt] self.max = [dim 0 max, dim 1 max]

  For static dimension, it has min==opt==max, thus the p shape param in the ctor can be an integer

class tensorrt_llm.functional.LayerNormPositionType(value)

  Bases: `IntEnum`

  An enumeration.

  post_layernorm = 1
  pre_layernorm = 0

class tensorrt_llm.functional.LayerNormType(value)

  Bases: `IntEnum`

  An enumeration.

  GroupNorm = 2
  LayerNorm = 0
  RmsNorm = 1

class tensorrt_llm.functional.MLPType(value)

  Bases: `IntEnum`

  An enumeration.

  FusedGatedMLP = 2
  GatedMLP = 1
  MLP = 0

class tensorrt_llm.functional.PositionEmbeddingType(value)

  Bases: `IntEnum`

  An enumeration.

  alibi = 3
  alibi_with_scale = 4
  chatglm = 6
  static choices() → List[str]
  is_alibi() → bool
  is_rope() → bool
  learned_absolute = 0
  relative = 5
  rope_gpt_neox = 2
  rope_gptj = 1

class tensorrt_llm.functional.RotaryScalingType(value)

  Bases: `IntEnum`

  An enumeration.

  dynamic = 2
  linear = 1
  none = 0

class tensorrt_llm.functional.Tensor(name=None, dtype=None, shape=None, dim_range=None, is_network_input=True, location=<TensorLocation.DEVICE: 0>, network=None, trt_tensor=None)

  Bases: `object`

  The class to represent dense tensors.

  A dense tensor is named, has a shape and contains typed elements. Each dimension of a tensor can either be static or dynamic. Static dimensions are known at engine compilation by TensorRT. Dynamic dimensions can take values determined at runtime. The tensor can be located on the host (CPU) or the device (GPU).

  abs()

    See functional.abs.

  cast(dtype)

    See functional.cast.

  property dtype

    The type of the elements in the tensor.

  get_parent()

    Get the layer that produces this tensor.

  get_users()

    Get the layers that use this tensor as an input.

  is_dynamic(dim=None)

    If the argument ‘dim’ is None, that function returns a boolean that indicates if the tensor contains a dynamic dimension (True) or not (False). In that case, the first dimension is excluded (as it usually corresponds to the batch size). If the argument is an integer, that functions returns a boolean that indicates if the dimension ‘dim’ is dynamic (True) or not (False).

  is_trt_wrapper()

    Check if there is a trt.ITensor member inside, which is required for graph rewriter. In order to differentiate usages, it may be necessary to have an inheritance hierarchy.

  property location

    The physical location of the tensor (on the host or the device).

  mark_output(name, dtype)

    Mark a tensor as a network output.

    When a tensor is marked as an output, its content can be obtained after the execution of the TensorRT engine. The user is responsible for allocating buffers to store the output tensors when preparing the execution of the TensorRT engine.

  max(dim, keepdim=False)

    See functional.max.

  mean(dim, keepdim=False)

    See functional.mean.

  property name

    The name of the tensor.

  ndim()

    Returns the rank (i.e. the number of dimensions) of the tensor.

  property network
  permute(dims)

    See functional.permute.

  rank()

    Returns the rank (i.e. the number of dimensions) of the tensor.

  replace_all_uses_with(new_tensor)

    Replace all uses of this tensor as an input to consumer layers

  property shape

    The shape of the tensor.

  size(dim=None)

    Returns the shape of the tensor if the dim parameter is None. Otherwise, returns a size of the dimension indicated by dim. The behavior is undefined if dim is negative or exceeds the rank of the tensor.

  split(split_size_or_sections, dim=0)

    See functional.split.

  sqrt()

    See functional.sqrt.

  transpose(dim0, dim1)

    See functional.transpose.

  view(shape, zero_is_placeholder=True)

    See functional.view.

tensorrt_llm.functional.abs(input: ~tensorrt_llm.functional.Tensor, *, op: ~tensorrt.tensorrt.UnaryOperation = <UnaryOperation.ABS: 4>) → Tensor

  Add an elementwise operation on a single input.

  The following closures are defined in functional.*:

  > round for op=trt.UnaryOperation.ROUND sqrt for op=trt.UnaryOperation.SQRT exp for op=trt.UnaryOperation.EXP sin for op=trt.UnaryOperation.SIN cos for op=trt.UnaryOperation.COS abs for op=trt.UnaryOperation.ABS

  It is implemented using the IUnaryLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - op – trt.UnaryOperation The unary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.activation(input: Tensor, act_type: ActivationType) → Tensor

  Add an activation function.

  Parameters:

    - input – Tensor The input tensor on which the activation function is applied.

    - act_type – trt.ActivationType The type of the activation (RELU, TANH, SIGMOID, …).

  The following closures are defined in functional.*:

  > relu for op=trt.ActivationType.RELU tanh for op=trt.ActivationType.TANH sigmoid for op=trt.ActivationType.SIGMOID

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.add(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.SUM: 0>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.allgather(tensor: Tensor, group: List[int]) → Tensor

  Add an operation that performs a collective all-gather.

  Let’s define ‘world_size’ as the length of the ‘group’ list. That functions creates a layer to gather ‘world_size’ tensors distributed amongst the ‘world_size’ participating ranks (one GPU per rank).

  The list ‘group’ contains the identifiers of the ranks participating into the collective operation.

  The tensors in the different ranks must be 1D tensors (or views) and the output tensor will have that same shape.

  Given the ‘section_size = input.shape[0] / world_size’, each rank contributes a section of its input tensor that correspond to ‘rank*section_size:(rank+1)*section_size’.

  That operation is implemented using a plugin that wraps the NCCL all-gather collective operation. See https://docs.nvidia.com/deeplearning/nccl/user-guide/docs/usage/collectives.html#allgather for details.

  Parameters:

    - tensor – Tensor The input tensor.

    - group – List[int] The ranks participating into the all-gather operation.

  Returns:

    The tensor produced by that layer.

tensorrt_llm.functional.allreduce(tensor: Tensor, group: List[int], workspace: Tensor | None = None, instance_id: int = 0, strategy: AllReduceStrategy | None = None) → Tensor

  Add an operation that performs a collective all-reduce.

  Let’s define ‘world_size’ as the length of the ‘group’ list. That functions creates a layer to compute the sum of ‘world_size’ tensors distributed amongst the ‘world_size’ participating ranks (one GPU per rank).

  The list ‘group’ contains the identifiers of the ranks participating into the collective operation.

  The tensors in the different ranks must be 1D tensors (or views) and the output tensor will have that same shape. The output tensor will be replicated on the ‘world_size’ ranks.

  That operation is implemented using a plugin that wraps the NCCL all-reduce collective operation. See https://docs.nvidia.com/deeplearning/nccl/user-guide/docs/usage/collectives.html#allreduce for details.

  Parameters:

    - tensor – Tensor The input tensor.

    - group – List[int] The ranks participating into the all-reduce operation.

    - workspace – Optional[Tensor] When using CUSTOM or AUTO mode, a tensor containing pointers to memory visible to all GPUs. It should be 3 poitners per TP rank - ptr to data buffer, ptr to barriers in, ptr to barriers out. It must be initialized using IpcMemory class.

    - instance_id – int Used for synchronization with CUSTOM or AUTO. Corresponding plugins MUST have the same instance_id. I.e. GPU#0’s allreduce after MLP at layer i must have the same instance_id as GPU#1, GPU#2… Also, instance_id MUST be unique per model. There should not be two allreduce instances in GPU#0 that have the same id.

  Returns:

    The tensor produced by that layer.

tensorrt_llm.functional.arange(start: Tensor | int, end: Tensor | int, dtype: str) → Tensor

  Add an operation to fill a 1D tensor.

  The tensor is filled with the values between start and end with a step of 1 between the different elements. In pseudo-code, it corresponds to a tensor populated with the values:

  > output = Tensor([dtype(ii) for ii in range(start, end, 1)])

  For example, a call to arange(3, 6, ‘int32’) will add an operation to the TensorRT graph that will produce [3, 4, 5] when executed. The call to arange(2, 5, ‘float32’) will add a layer to generate [2.0, 3.0, 4.0].

  This operation is implemented using a tensorrt.IFillLayer in trt.FillOperation.LINSPACE mode.

  Parameters:

    - start – Union[Tensor, int] The starting point of the range.

    - end – Union[Tensor, int] The end point of the range.

    - dtype – str The type of the elements. See _str_to_trt_dtype_dict in _utils.py for a list of supported types and type names.

  Returns:

    The tensor produced by the fill layer. It is a 1D tensor containing end-start elements of type dtype.

tensorrt_llm.functional.argmax(input: Tensor, dim: int, keepdim: bool = False) → Tensor

  Add an argmax operation.

  As explained in the ONNX documentation,

  > https://github.com/onnx/onnx/blob/main/docs/Operators.md#argmax

  that function creates a layer computing the indices of the max elements of the input tensor’s element along the provided dim. The resulting tensor has the same rank as the input if keepdims is True. If keepdims is False, then the resulting tensor has the reduced dimension pruned.

  Parameters:

    - input – Tensor The input tensor.

    - dim – int The dimension in which to compute the argmax indices.

    - keepdim – bool Do we keep the dimension along which the reduction is performed? Yes, if set to True, no otherwise.

  Returns:

    The tensor produced by this argmax operation.

tensorrt_llm.functional.assertion(condition: Tensor, message: str = '') → None

tensorrt_llm.functional.avg_pool2d(input: Tensor, kernel_size: Tuple[int], stride: Tuple[int] | None = None, padding: Tuple[int] | None = (0, 0), ceil_mode: bool = False, count_include_pad: bool = True) → Tensor

tensorrt_llm.functional.bert_attention(tensor: Tensor, input_lengths: Tensor, num_heads: int, head_size: int, q_scaling: float, relative_attention: bool = False, relative_attention_bias: Tensor | None = None, max_distance: int = 0, max_input_length: Tensor | None = None) → Tuple[ Tensor ]

  Add an operation that performs the multi-head attention in BERT.

  The multihead-attention (MHA) is the sequence of a batched matmul, a softmax and a batched matmul as described in https://arxiv.org/abs/1706.03762. That function adds an operation that performs those computations using a single GPU kernel.

  The input tensor contains the Q, K and V elements. It is a 2D tensor and its shape is ‘[sum_of_tokens, 3*hidden_dim]’ where the ‘sum_of_tokens’ is the sum of the sequence lengths in the batch.

  In MHA, the output of the Q*K^T product is scaled by a constant value that is computed as:

  > 1.f / (q_scaling * sqrt(head_size)).

  That ‘q_scaling’ constant is the last argument of that function.

  That layer is implemented using a plugin (see bertAttentionPlugin).

  Parameters:

    - tensor – Tensor The QKV input tensor.

    - input_lengths – Tensor The length of each sequence. It is a 1D tensor of size ‘batch_size’.

    - num_heads – int The number of heads.

    - head_size – int The size of each head.

    - q_scaling – float The factor to compute the scaling factor to scale the output of the ‘Q*K^T’ product.

    - relative_attention – bool = False If enable relative attention.

    - relative_attention_bias – Tensor = None The relative attention bias [num_heads, max_seq_len, max_seq_len], or The relative attention embedding table for implicit mode, [num_heads, num_buckets].

    - max_distance – int = 0 The maximum distance of relative position in attention, for implicit mode. Default value is 0, meaning to use the regular mode of relative attention bias. Implicit mode is only enabled when passing in non-zero positive max_distance value. See relative attention bias in docs/gpt_attention.md

    - max_input_length – Tensor = None The maximum input sequence length represented by Tensor shape. Requires for remove_input_padding to pre-define plugin workspace size.

  Returns:

    The tensor produced by that layer.

tensorrt_llm.functional.broadcast_helper(left: Tensor | int | float, right: Tensor | int | float) → Tuple[ Tensor , Tensor ]

  Helper function to perform a broadcast.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

  Returns:

    A pair of tensors of same rank.

tensorrt_llm.functional.cast(input: Tensor, dtype: str | DataType)

  Add a cast operation.

  For an input tensor of type INT8, this function sets the dynamic range of the input to [-127, 127] for automatic dequantization. For a cast into INT8, that function sets the dynamic range of the output to [-127, 127] for automatic quantization.

  Parameters:

    - input – Tensor The input tensor on which the cast is applied.

    - dtype – str or trt.DataType The data type of the output tensor after the cast. When ‘dtype’ is provided as a string, it must be a name amongst the valid names. See _str_to_trt_dtype_dict in _utils.py for a list of supported types and type names.

  Returns:

    The tensor produced by the inserted layer.

tensorrt_llm.functional.chunk(tensor: Tensor, chunks: int, dim: int = 0) → Tensor

  Add an operation that splits a tensor into sub-tensors.

  This operation creates a list of tensors that are obtained from the input tensor by chunking it along the dimension ‘dim’. It produces ‘chunks’ sub-tensors.

  That operation is only defined for static tensors (no dynamic dimension) and the size of the tensor in the dimension ‘dim’ must be a multiple of ‘chunks’: ‘input.shape[dim] % chunks == 0’.

  It maps to ‘split’ with ‘split_size = input.shape[dim] / chunks’.

  Parameters:

    - tensor – Tensor The input tensor to slice.

    - chunks – int The number of slices to split the input tensor into.

    - dim – int The dimension of the tensor to slice.

  Returns:

    The list of tensors produced by the different operations.

tensorrt_llm.functional.clip(input: Tensor, alpha: float, beta: float) → Tensor

  Add a CLIP operation that sets the range to [alpha, beta].

  Parameters:

    - input – Tensor The input tensor on which the activation function is applied.

    - alpha – float The lower bound of the CLIP function.

    - beta – float The upper bound of the CLIP function.

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.concat(inputs: Sequence[ Tensor | int], dim: int = 0) → Tensor

  Add an operation to concatenate tensors.

  The function creates an operation that concatenates the tensors from the sequence ‘inputs’. The concatenation is done along the dimension ‘dim’.

  All the tensors in ‘inputs’ must have the same shape expect for the dimension ‘dim’.

  > for ii in range(inputs[0].rank()):

  >   assert (ii == dim) or all(inp.shape[ii] == inputs[0].shape[ii] for inp in inputs)

  The shape of the output tensor is defined as:

  > for ii in range(inputs[0].rank()):

  >   # Same size as all the inputs in dimension ii != dim. output.shape[ii] = inputs[0].shape[ii]

  >   # Sum of the sizes in the different inputs in dimension ‘dim’. if ii == dim:

  >   > for jj in range(1, len(inputs)):

  >   >   output.shape[ii] += inputs[jj].shape[ii]

  For example, given a sequence of two 2D tensors [[0, 1], [2, 3]] and [[4, 5], [6, 7]] both of shape [2, 2],

  > concat(inputs, 0)

  will produce [[[0, 1], [2, 3]], [[4, 5], [6, 7]]] of shape [4, 2] and

  > concat(inputs, 1)

  will produce [[0, 1, 4, 5], [2, 3, 6, 7]] of shape [2, 4].

  Parameters:

    - inputs – Sequence[Union[Tensor, int]] The sequence of tensors to concatenate. For integers, that function creates constant tensors.

    - dim – int The dimension in which the concatenation is performed.

  Returns:

    A tensor that contains the concatenation of the tensors.

tensorrt_llm.functional.constant(ndarray: ndarray) → Tensor

  Add a constant layer.

  TensorRT graphs encapsulate constant values in the form of constant layers (tensorrt.IConstantLayer). That function creates such a layer from a Numpy array of values. After compilation of the network by TensorRT, those weights are stored in the serialized TensorRT engine.

  Parameters:

    ndarray – numpy.ndarray The array of values (weights) encapsulated by this constant layer.

  Returns:

    The tensor produced by the inserted layer.

tensorrt_llm.functional.constant_to_tensor_(input: ~tensorrt_llm.functional.Tensor | int | float, dtype: ~tensorrt.tensorrt.DataType = <DataType.FLOAT: 0>) → Tensor

tensorrt_llm.functional.conv2d(input: Tensor, weight: Tensor, bias: Tensor | None = None, stride: Tuple[int, int] = (1, 1), padding: Tuple[int, int] = (0, 0), dilation: Tuple[int, int] = (1, 1), groups: int = 1) → Tensor

tensorrt_llm.functional.conv_transpose2d(input: Tensor, weight: Tensor, bias: Tensor | None = None, stride: Tuple[int, int] = (1, 1), padding: Tuple[int, int] = (0, 0), output_padding: Tuple[int, int] = (0, 0), dilation: Tuple[int, int] = (1, 1), groups: int = 1) → Tensor

tensorrt_llm.functional.cos(input: ~tensorrt_llm.functional.Tensor, *, op: ~tensorrt.tensorrt.UnaryOperation = <UnaryOperation.COS: 7>) → Tensor

  Add an elementwise operation on a single input.

  The following closures are defined in functional.*:

  > round for op=trt.UnaryOperation.ROUND sqrt for op=trt.UnaryOperation.SQRT exp for op=trt.UnaryOperation.EXP sin for op=trt.UnaryOperation.SIN cos for op=trt.UnaryOperation.COS abs for op=trt.UnaryOperation.ABS

  It is implemented using the IUnaryLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - op – trt.UnaryOperation The unary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.div(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.DIV: 5>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.einsum(einsum_eq: str, inputs: Sequence[ Tensor ]) → Tensor

  Add an Einsum operation.

  That operation maps to tensorrt.IEinsumLayer. As explained in the TensorRT documentation, this layer implements a summation over the elements of the inputs along dimensions specified by the equation parameter, based on the Einstein summation convention. The layer can have one or more inputs of rank >= 0. All the inputs must be of same data type. This layer supports all TensorRT data types except bool. There is one output tensor of the same type as the input tensors. The shape of output tensor is determined by the equation.

  The equation specifies ASCII lower-case letters for each dimension in the inputs in the same order as the dimensions, separated by comma for each input. The dimensions labeled with the same subscript must match or be broadcastable. Repeated subscript labels in one input take the diagonal. Repeating a label across multiple inputs means that those axes will be multiplied. Omitting a label from the output means values along those axes will be summed. In implicit mode, the indices which appear once in the expression will be part of the output in increasing alphabetical order. In explicit mode, the output can be controlled by specifying output subscript labels by adding an arrow (‘->’) followed by subscripts for the output. For example, “ij,jk->ik” is equivalent to “ij,jk”. Ellipsis (‘…’) can be used in place of subscripts to broadcast the dimensions. See the TensorRT Developer Guide for more details on equation syntax.

  Many common operations can be expressed using the Einsum equation. For .. rubric:: Example

  Matrix Transpose: ij->ji Sum: ij-> Matrix-Matrix Multiplication: ik,kj->ij Dot Product: i,i-> Matrix-Vector Multiplication: ik,k->i Batch Matrix Multiplication: ijk,ikl->ijl Batch Diagonal: …ii->…i

  Note that TensorRT does not support ellipsis or diagonal operations so, neither, does TensorRT-LLM.

  Parameters:

    - einsum_eq – str The Einsum equation.

    - inputs – Sequence[Tensor] The sequence of inputs consumed by the Einsum operation.

  Returns:

    The tensor produced by the Einsum operation.

tensorrt_llm.functional.elementwise_binary(left: Tensor | int | float, right: Tensor | int | float, op: ElementWiseOperation) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.embedding(input: Tensor, weight: Tensor, tp_size=1, tp_group=None, sharding_dim=0, tp_rank=None, workspace: Tensor | None = None, instance_id: int = 0) → Tensor

  Add an operation to perform embedding lookup.

  That operation performs the embedding lookup. The ‘input’ tensor contains the identifiers of the rows of ‘weight’ to gather.

  1. Distribute the embedding lookup table over multiple GPU When ‘tp_size’ is greater than 1 and the ‘tp_group’ is defined, this embedding lookup is distributed among multiple GPUs.

  When ‘sharding_dim==0’, each GPU stores a subset of the rows of the embedding table rows(that number of rows per GPU is given by weights.shape[0] and the offset to the 1st row stored on the GPU is given by rank * weights.shape[0]). Each parallel rank will query all the indices and set 0s for the weights that are not stored on the associated GPU. To compute the final result, a parallel all-reduce operation is added to the TensorRT graph. That lookup can be performed using either the plugin or the operators TensorRT support.

  When’sharding_dim==1’, each GPU stores a subset of the embedding table’s columns. Each rank can obtain a portion of the embedding results. Then the embedding is collected using the all-gather operation. Related transposition operations are also used to obtain the final results.

  2. Store embedding lookup table as a whole When ‘tp_size’ is not greater than 1, the embedding lookup table will not be divided. In this case, when the default_net().plugin_config.lookup_plugin is set, the operation is implemented using a plugin (without the all-reduce operation). Otherwise, this operation is implemented using the standard IGatherLayer in TensorRT.

  Parameters:

    - input – Tensor The input tensor the contains the indices to perform the lookup.

    - weight – Tensor The table to gather from.

    - tp_size – int The number of GPUs collaborating to perform that embedding.

    - tg_group – Optional[List[int]] The group of world ranks participating in the all-reduce when tp_size > 1.

    - sharding_dim – int sharding_dim = 0 means that we shard the embedding table in vocab dim; sharding_dim = 1 means that we shard the embedding table in embedding dim.

    - tp_rank – int The tensor parallelism rank. Used to calculate offset in TP on vocab dim.

    - workspace – Optional[Tensor] See allreduce’s documentation for workspace.

    - instance_id – int See allreduce’s documentation for instance_id.

  Returns:

    The tensor produced by the embedding lookup layer.

tensorrt_llm.functional.eq(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.EQUAL: 11>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.exp(input: ~tensorrt_llm.functional.Tensor, *, op: ~tensorrt.tensorrt.UnaryOperation = <UnaryOperation.EXP: 0>) → Tensor

  Add an elementwise operation on a single input.

  The following closures are defined in functional.*:

  > round for op=trt.UnaryOperation.ROUND sqrt for op=trt.UnaryOperation.SQRT exp for op=trt.UnaryOperation.EXP sin for op=trt.UnaryOperation.SIN cos for op=trt.UnaryOperation.COS abs for op=trt.UnaryOperation.ABS

  It is implemented using the IUnaryLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - op – trt.UnaryOperation The unary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.expand(input: Tensor, expand_shape: Tensor ) → Tensor

  Add an operation to expand a tensor.

  The operation expands the input tensor in the singleton dimensions to the size indicated by the corresponding dimension in the expand_shape tensor. In other words, given an input tensor with dimensions of size 1, those dimensions will be expanded to the size in expand_shape.

  For example, a tensor of shape [4, 3, 1, 3] will be expanded to a tensor of shape [4, 3, 2, 3] by the layer created using expand(input, [4, 3, 2, 3]).

  The expansion may either replicate the values or be mapped to a view with a stride of 0 in the expanded dimensions. For example, for a tensor [[3, 2]] of shape [1, 2],

  > expand([[3, 2]], [2, 2])

  can be used to expand the input to [[3, 2], [3, 2]].

  This operation is implemented using a tensorrt.ISliceLayer. The current implementation does not verify that non singleton dimensions are not shrunk. In other words, for an input of shape [4, 1, 2],

  > expand(input, [3, 2, 2])

  will produce a tensor of shape [3, 2, 2]. That behaviour is subject to change in the future.

  Parameters:

    - input – Tensor The input tensor.

    - expand_shape – Tensor The new shape of the expanded tensor.

  Returns:

    The tensor produced by the expand layer.

tensorrt_llm.functional.expand_dims(input: Tensor, dim: int | Sequence[int]) → Tensor

  Add an operation to expand the tensor shape with singleton dimensions.

  That function adds a tensorrt.IShuffleLayer to the network. Given an ‘input’ of rank N and a sequence of M dimensions, the output tensor produced by this operation (when executed by TensorRT) will have a rank of N+M. Singleton dimensions will be inserted at the different positions in ‘dim’.

  The pseudo-code for that operation is:

  > new_shape, ii = [], 0 for jj in range(input.rank() + len(dim)):

  > > new_shape.append(1 if jj in dims else input.shape[ii++])

  For example, for a tensor of shape [3, 4, 1, 5]

  > expand_dims(input, [0, 2])

  will produce a tensor of shape [1, 3, 1, 4, 1, 5].

  Parameters:

    - input – Tensor The input tensor to expand.

    - dim – Union[int, Sequence[int]] The positions in the output tensor where to insert singleton dimensions.

  Returns:

    The tensor produced by the shuffle layer.

tensorrt_llm.functional.expand_dims_like(left: Tensor | int | float, right: Tensor ) → Tensor

  Add an operation to expand the first tensor to the same rank as the second tensor.

  That function takes a first tensor. It also accepts an integer or a float, in which case it creates a constant tensor from it. In both cases, the rank of that first tensor is compared to the rank of the second tensor. If they are of the same rank, the first tensor is returned. Otherwise, the first tensor is expanded on the left to match the rank of the second tensor.

  Note that the shapes do not have to match, only the rank is considered in that function.

  For example, for a pair of tensors of shapes [3, 4] and [4, 3, 2], the first tensor will be expanded to a tensor of rank 3 and shape [1, 3, 4].

  Parameters:

    - left – Union[Tensor, int, float] The first tensor to expand. When a scalar value is provided as a parameter, that function first creates a tensor before expanding it (if needed).

    - right – Tensor The reference tensor to match.

  Returns:

    The tensor produced by the shuffle layer.

tensorrt_llm.functional.expand_mask(mask: Tensor, tgt_len: Tensor | None = None) → Tensor

  Expand an attention mask.

  That function adds the sequence of operations to expand from a tensor of shape ‘[batch_size, src_seq_len]’ to a tensor of shape ‘[batch_size, 1, tgt_seq_len, src_seq_len]’. It can be used to create the mask applied to the Q*K^T product before the softmax operation in the multihead-attention block.

  Parameters:

    - mask – Tensor The input mask

    - tgt_len – Optional[Tensor] The dimension of the 3rd dimension in the output tensor. If None, the 2nd dimension of the input is used.

  Returns:

    The tensor created by that sequence of operations.

tensorrt_llm.functional.flip(input: Tensor, dims: Sequence[int]) → Tensor

  Reverses the order of an n-D tensor along given axis in dims.

  That flip operation maps to a TensorRT ISliceLayer. For the dimensions listed in dims it copies the elements from the last one to the first one (from (N-1) down to 0 with a step of -1). For the dimensions not in ‘dims’, it copies the elements from the first one to the last one (from 0 to N-1 with a step of 1).

  Parameters:

    - input – Tensor The input tensor on which the cast is applied.

    - dims – list or tuple The axes to flip. Negative indices are supported.

  Returns:

    The tensor produced by the inserted layer.

tensorrt_llm.functional.gather(input: Tensor, dim: int, indices: Tensor | int) → Tensor

  Add an operation to gather elements from a tensor.

  That function implements the GatherElements operator from the ONNX specification as described in

  > https://github.com/onnx/onnx/blob/main/docs/Operators.md#GatherElements

  The input and indices arguments must have the same rank >= 1. The operation will produce a tensor with the same shape as the indices tensor. The axis is the dimension to gather on.

  As shown in the ONNX description, for a 3D tensor, the output is:

  > out[i][j][k] = input[indices[i][j][k]][j][k] if axis = 0, out[i][j][k] = input[i][indices[i][j][k]][k] if axis = 1, out[i][j][k] = input[i][j][indices[i][j][k]] if axis = 2.

  For example,

  > gather([[4, 2], [5, 3]], 0, [[1, 0], [0, 1]])

  will produce [[5, 2], [4, 3]].

  > gather([[1, 2, 3], [4, 5, 6], 1, [[1], [0]])

  will produce [[2], [4]]. See the ONNX documentation for more examples.

  That operation maps to the TensorRT IGatherLayer.

  Parameters:

    - input – Tensor The input tensor to gather elements from.

    - dim – int The dimension to gather on.

    - indices – Union[Tensor, int] The positions in the ‘dim’ dimension to gather from.

  Returns:

    The tensor containing the gathered elements. It has the same shape as the indices tensor.

tensorrt_llm.functional.gather_last_token_logits(hidden_states: Tensor, last_token_ids: Tensor, remove_input_padding: bool) → Tensor

  Extract the logits that correspond to the last token from the hidden states.

  That function adds the operations to extract the logits of the last tokens in a batch of sequences.

  Depending on whether ‘remove_input_padding’ is ‘True’ or ‘False’, that function assumes inputs of different shapes.

  When ‘remove_input_padding’ is ‘True’, the ‘hidden_states’ tensor is assumed to be packed. It has a shape ‘[num_tokens, hidden_dim]’ where ‘num_tokens’ is the sum of the lengths of the sequences in the batch and ‘hidden_dim’ is the hidden dimension. The ‘last_tokens_ids’ is a 1D tensor that encodes the inclusive prefix-sums of the lengths of the sequences in the batch.

  When ‘remove_input_padding’ is ‘False’, the ‘hidden_states’ tensor is assumed to be padded. It has a shape ‘[batch_size, max_seqlen, hidden_dim]’ where ‘max_seqlen’ is the length of the longest sequence in the batch and ‘hidden_dim’ is the hidden dimension. The ‘last_token_ids’ is a 1D tensor that encodes the length of each sequence in the batch.

  In both cases, that function produces a tensor of shape ‘[batch_size, hidden_size]’ where the row at index ‘i’ corresponds to the logits of the last token from the ‘i’-th sequence.

  Parameters:

    - hidden_states – Tensor The hidden states

    - last_token_ids – Tensor The inclusive prefix-sum of the lengths or the lengths of the sequences in the batch.

    - remove_input_padding – bool Indicate if the hidden_states are packed (‘True’) or padded (‘False’).

  Returns:

    The tensor created by that sequence of operations.

tensorrt_llm.functional.geglu(x: Tensor ) → Tensor

  Add a Gated-GELU operation.

  That function takes a tensor, splits it into two halves along the last dimension, applies GELU to the second half and multiply the results. The behaviour is undefined if the last dimension is not even.

  Parameters:

    input – Tensor The input tensor on which the activation function is applied.

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.gelu(x: Tensor ) → Tensor

  Add a GELU operation.

  Parameters:

    input – Tensor The input tensor on which the activation function is applied.

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.generate_alibi_biases(slopes: Tensor, key_length: Tensor ) → Tensor

  Compute the ALiBi biases as described in https://arxiv.org/abs/2211.05100.

  The ALiBi biases are added to the result of the Q*K^T product in the multihead-attention block.

  Parameters:

    - slopes – Tensor The slopes.

    - key_length – Tensor The size of the K vector per head.

  Returns:

    A constant tensor that contains the ALiBi biases.

tensorrt_llm.functional.generate_alibi_slopes(num_heads: int, dtype: ~tensorrt.tensorrt.DataType = <DataType.FLOAT: 0>, tp_size: int = 1, tp_rank: int = 0, alibi_scale: float = 1.0) → Tensor

  Compute the ALiBi slopes as described in https://arxiv.org/abs/2211.05100.

  Parameters:

    - num_heads – int The number of heads.

    - dtype – trt.DataType The data type of the returned slopes

    - tp_size – int The tensor parallelism size

    - tp_rank – int The tensor parallelism rank

  Returns:

    A constant tensor that contains the ALiBi slopes.

tensorrt_llm.functional.gpt_attention(tensor: Tensor, past_key_value: Tensor, sequence_length: Tensor, host_past_key_value_lengths: Tensor, host_max_kv_cache_lengths: Tensor, context_lengths: Tensor, cache_indirection: Tensor, host_request_types: Tensor, num_heads: int, num_kv_heads: int, hidden_size_per_head: int, q_scaling: float, rotary_embedding_dim: int, rotary_embedding_base: float = 10000.0, rotary_embedding_scale_type: RotaryScalingType = RotaryScalingType.none, rotary_embedding_scale: float = 1.0, rotary_embedding_max_positions: int = 1024, position_embedding_type: PositionEmbeddingType = PositionEmbeddingType.learned_absolute, kv_orig_quant_scale: Tensor = None, kv_quant_orig_scale: Tensor = None, kv_cache_quant_mode: QuantMode = None, max_context_length: int = None, mask_type: AttentionMaskType = AttentionMaskType.causal, alibi_slopes: Tensor = None, tp_size: int = 1, tp_rank: int = 0, kv_cache_block_pointers: Tensor = None, do_cross_attention: bool = False, cross_qkv: Tensor = None, cross_qkv_length: Tensor = None, encoder_input_lengths: Tensor = None, relative_attention_bias: Tensor = None, max_distance: int = 0, host_context_lengths: Tensor = None, qkv_bias: Tensor = None) → Tuple[ Tensor ]

  Add an operation that performs the multi-head attention in GPT-like models.

  The signature of the function will change in the future release - we are in the process of simplifying the API. The current version is still work-in-progress! The following API is provided with hints regarding the arguments that are likely to be removed or merged with others in the future release.

  See docs/gpt_attention.md for the documentation of that function.

  Parameters:

    - tensor – Tensor The input QKV tensor. Its shape is [batch_beam_size, max_seqlen, 3 * hidden_dim] in padded mode and [1, num_tokens, 3 * hidden_dim] in packed mode. See QKV Input in docs/gpt_attention.md.

    - past_key_value – Tensor The tensor that stores KV cache data. Its shape is [max_batch_size * max_beam_width, 2, num_heads, max_seqlen, hidden_dim_per_head] in contiguous mode and [max_blocks, 2, num_heads, num_tokens_per_block, hidden_dim_per_head] in paged mode. See KV Cache in docs/gpt_attention.md,

    - sequence_lengths – Tensor The tensor that stores the length of each sequence. Its shape is [batch_size]. See QKV Input in docs/gpt_attention.md,

    - past_key_value_length (host) – Tensor An INT32 tensor of shape [batch_size].

    - max_kv_cache_lengths (host) – Tensor An INT32 tensor of shape [1]. by default, the max_kv_cache_length is determined by the shape of cache_indir_table. And we support flexible max_kv_cache_length (or max_past_length) for each layer.

    - context_lengths – Tensor The tensor that stores the context-phase sequence length of each request. Its shape is [batch_size]. See QKV Input in doc/functional.py,

    - cache_indirection – Tensor The tensor to reconstruct the paths when using beam-search. Its shape is [batch_size, beam_width, max_seqlen]. See Beam-Search in docs/gpt_attention.md,

    - host_request_types – Tensor = None The tensor on the host that indicates if a request is in context or generation phase. Its shape is [batch_size]. See Inflight Batching in docs/gpt_attention.md,

    - num_heads – int The number of heads,

    - num_kv_heads – int The number of KV heads, generic to handle MHA/MQA/GQA,

    - hidden_size_per_head – int The hidden size per head,

    - q_scaling – float The value used to compute the scaling factor applied to the output of the Q*K^T product. See Scaling Factors in docs/gpt_attention.md,

    - rotary_embedding_dim – int The dimension to compute RoPE. Use 0 when position_embedding_type is not RoPE.

    - rotary_embedding_base – float The theta value to use for RoPE. Ignored when position_embedding_type is not RoPE.

    - rotary_embedding_scale_type –

      RotaryScalingType The scaling type of RoPE. Ignored when position_embedding_type is not RoPE. Possible rotary scaling type:

      > - RotaryScalingType.none

      > - RotaryScalingType.linear

      > - RotaryScalingType.dynamic

    - rotary_embedding_scale – float The scale value to use for linear/dynamic scaling in RoPE. Ignored when position_embedding_type is not RoPE. Must be set to 1 (default) if rotary_embedding_scale_type is none.

    - rotary_embedding_max_positions – int Needed only for dynamic RoPE scaling. Ignored otherwise.

    - position_embedding_type –

      PositionEmbeddingType The position embedding type:

      > - PositionEmbeddingType.learned_absolute

      > - PositionEmbeddingType.relative

      > - PositionEmbeddingType.rope_gptj

      > - PositionEmbeddingType.rope_gpt_neox

      > - PositionEmbeddingType.alibi

      > - PositionEmbeddingType.alibi_with_scale

    - kv_orig_quant_scale – Tensor The tensor to store the scaling factor for quantization to INT8/FP8 in the KV cache. Its shape is [1]. See INT8/FP8 KV Cache in docs/gpt_attention.md,

    - kv_quant_orig_scale – Tensor The tensor to store the scaling factor for dequantization from INT8/FP8 in the KV cache. Its shape is [1]. See INT8/FP8 KV Cache in docs/gpt_attention.md,

    - kv_cache_quant_mode – QuantMode (int flags) Do we enable the INT8 or FP8 KV cache?

    - max_context_length – int32_t The length of the longest input sequence. See QKV Input in docs/gpt_attention.md,

    - mask_type –

      int = 1 The type of mask:

      > - tensorrt_llm.layers.AttentionMaskType.padding for BERT,

      > - tensorrt_llm.layers.AttentionMaskType.causal for GPT,

      > - tensorrt_llm.layers.AttentionMaskType.bidirectional for ChatGLM-6B,

      > - tensorrt_llm.layers.AttentionMaskType.bidirectionalglm for GLM-10B,

    - alibi_slopes – Tensor The ALiBi slopes. The ALiBi bias is computed on-the-fly in the kernel when possible,

    - tp_size – int The number of processes/GPUs when tensor parallelism is activated,

    - tp_rank – int The rank of that process (when running tensor parallelism),

    - kv_cache_block_pointers – The tensor of block pointers for the KV cache. Its shape is [max_batch_size, max_beam_width, 2, max_blocks_per_sequence * 2] See KV cache section in docs/gpt_attention.md,

    - do_cross_attention – bool = False Do we use this as cross attention instead of self attention,

    - cross_qkv – Tensor = None The QKV tensor of encoder output hidden states. Its shape is [batch_size, max_seqlen, 3 * hidden_dim] in padded mode and [1, num_tokens, 3 * hidden_dim] in packed mode,

    - cross_qkv_length – Tensor = None The length of the longest encoder output sequence,

    - encoder_input_lengths – Tensor The tensor that stores the length of each encoder input sequence. Its shape is [batch_size],

    - relative_attention_bias – Tensor = None The relative attention bias [num_heads, max_seq_len, max_seq_len], or The relative attention embedding table for implicit mode, [num_heads, num_buckets].

    - max_distance – int = 0 The maximum distance of relative position in attention, for implicit mode. Default value is 0, meaning to use the regular mode of relative attention bias. Implicit mode is only enabled when passing in non-zero positive max_distance value. See relative attention bias in docs/gpt_attention.md

    - host_context_lengths – Tensor = None A host tensor that contains the lengths of the different inputs,

    - qkv_bias – Tensor = None,

  Returns:

    The tensor produced by that layer.

tensorrt_llm.functional.group_norm(input: Tensor, num_groups: int, weight: Tensor | None = None, bias: Tensor | None = None, eps: float = 1e-05)

tensorrt_llm.functional.gt(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.GREATER: 12>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.identity(input: Tensor ) → Tensor

  Add an identity operation.

  TODO: Document why it can be done using a plugin!!!

  Parameters:

    input – Tensor The input tensor.

  Returns:

    The tensor produced by this identity operation.

tensorrt_llm.functional.index_select(input: Tensor, dim: int, index: Tensor ) → Tensor

  Add an operation to select slices of elements from a tensor.

  Given an input tensor, that function creates an operation that selects the slices of elements in the dimension ‘dim’ at the indices listed in ‘index’ to create a new tensor. The output tensor has the same rank as the input tensor.

  The ‘index’ is a tensor of rank 1.

  For example, on input=[[4, 2, 5], [2, 1, 2], [4, 7, 1]], which has a shape [3, 3],

  > index_select(input, 0, [0, 1])

  will create a tensor of shape [2, 3] that contains the [[4, 2, 5], [2, 1, 2]].

  Regarding the shape of the output tensor, the dimension ‘dim’ has the same size as the ‘index’ tensor. It means that for a input tensor of shape [4, 2, 6, 3],

  > index_select(input, 2, [1, 4])

  will select the 2nd and 5th slices (index == 1 or 4) from the 3rd dimension (dim == 2) and return a tensor of shape [4, 2, 2, 3] (i.e. the 3rd dimension is shrunk to 2).

  Note that this operation can also be used to expand a tensor in the ‘dim’ dimension, for example, on input [[0, 1], [2, 3]],

  > index_select(input, 1, [0, 0, 0])

  will produce a tensor of shape [2, 3] containing [[0, 0, 0], [2, 2, 2]].

  That operation maps to the TensorRT IGatherLayer.

  Parameters:

    - input – Tensor The input tensor to select from.

    - dim – int The dimension to select from.

    - index – Tensor The indices of the slices in the ‘dim’ dimension to select.

  Returns:

    The tensor containing the selected slices.

tensorrt_llm.functional.interpolate(input: Tensor, size: List[int] | int | None = None, scale_factor: float | List[float] | None = None, mode: str = 'nearest', align_corners: bool = False, recompute_scale_factor: bool = False, antialias: bool = False) → Tensor

tensorrt_llm.functional.is_gated_activation(activation)

  Is a given activation function gated?

  Parameters:

    activation – str The name of the activation function.

  Returns:

    True if the function is gated, False otherwise.

tensorrt_llm.functional.layer_norm(input: Tensor, normalized_shape: int | Tuple[int], weight: Tensor | None = None, bias: Tensor | None = None, eps: float = 1e-05, use_diff_of_squares: bool = True) → Tensor

  Add a layer-norm operation on a tensor.

  That operation applies the layer-normalization to its input tensor. In its simplest form, for large language models, the ‘normalized_shape’ should be set to the hidden dimension of the activation tensor. Otherwise, it is the shape of the normalized fraction of the tensor (starting from the right-most dimension).

  The ‘weight’ tensor corresponds to ‘gamma’ in the layer-norm formula and ‘bias’ is ‘beta’. The ‘eps’ value is added to the variance before computing the squared-root.

  This implementation (when using the plugin) supports an additional flag to enable/disable the use of a difference of squares (‘Var = Mean(X^2) - Mean(X)^2’).

  Parameters:

    - input – Tensor The tensor to normalize.

    - normalized_shape – Union[int, Tuple[int]] The shape of the sub-tensor that is normalized. Use ‘hidden_dim’ to normalize the inner-most dimension of an activation tensor in LLMs.

    - weight – Optional[Tensor] = None The ‘gamma’ term in layer-norm. Its shape must be ‘normalized_shape’.

    - bias – Optional[Tensor] = None The ‘beta’ term in layer-norm. Its shape must be ‘normalized_shape’.

    - eps – float The epsilon term to be added to the variance in the squared-root.

    - use_diff_of_squares – bool Does the plugin use the difference of squares to compute the variance?

  Returns:

    The output tensor of that operation.

tensorrt_llm.functional.lora_plugin(input: Tensor | None = None, in_hidden_size: int = 0, out_hidden_size: int = 0, host_request_types: Tensor | None = None, transa: bool = False, transb: bool = False, host_context_lengths: Tensor | None = None, max_context_length: int = 0, max_low_rank: int = 0, lora_ranks: Tensor | None = None, lora_weights_pointers: Tensor | None = None)
  Parameters:

    - lora_ids – cpu Tensor = None A tensor that contains the lora ids of different inputs.

    - in_hidden_size/out_hidden_size – int the lora computation workflow is [M, in_hidden_size] -> [M, low_rank] -> [M, out_hidden_size]

    - host_request_types – Tensor = None The tensor on the host that indicates if a request is in context or generation phase. Its shape is [batch_size]. See Inflight Batching in docs/gpt_attention.md,

    - transa – bool Is the first input transposed? Set to ‘True’ if you want the first input to be transposed, ‘False’ otherwise.

    - transb – bool Is the second input transposed? Set to ‘True’ if you want the second input to be transposed, ‘False’ otherwise.

    - host_context_lengths – cpu Tensor = None A host tensor that contains the lengths of the different inputs,

    - max_context_length – int Maximum length during context phase, used to determine the workspace size.

    - max_low_rank – int Maximum low_rank, used to determine the workspace size.

    - lora_ranks – cpu Tensor with shape [batch_size] The low_rank of each request

    - lora_weights_pointers – cpu int64 Tensor with shape [batch_size, 2] The weights pointers of each request. Consist of in_pointer and out_pointer.

  Returns:

    The tensor produced by that layer.

tensorrt_llm.functional.lt(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.LESS: 13>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.matmul(input: Tensor, mat2: Tensor, transa: bool = False, transb: bool = False) → Tensor

  Add a matrix multiplication.

  That operation maps to a tensorrt.IMatrixMultiplyLayer layer. As explained in the TensorRT documentation, it computes the inner product between the two inputs after applying an optional transposition on the inputs.

  Parameters:

    - input – Tensor The first tensor (often called A).

    - mat2 – Tensor The second tensor (often called B).

    - transa – bool Is the first input transposed? Set to ‘True’ if you want the first input to be transposed, ‘False’ otherwise.

    - transb – bool Is the second input transposed? Set to ‘True’ if you want the second input to be transposed, ‘False’ otherwise.

  Returns:

    The tensor produced by the inserted layer.

tensorrt_llm.functional.max(input: Tensor, dim: int, keepdim: bool = False) → Tensor

  Add an operation to compute the max along a dimension.

  Computes the max along the dimension ‘dim’ of the input tensor.

  It is implemented using the IReduceLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - dim – int The dimension along which the mean is computed.

    - keepdim – bool Is the dimension kept in the reduced tensor? When True the dimension is kept, it is removed from the shape otherwise.

  Returns:

    The tensor produced by this reduction operation.

tensorrt_llm.functional.maximum(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.MAX: 2>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.mean(input: Tensor, dim: int, keepdim: bool = False) → Tensor

  Add an operation to compute the mean along a dimension.

  Computes the mean along the dimension ‘dim’ of the input tensor.

  It is implemented using the IReduceLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - dim – int The dimension along which the mean is computed.

    - keepdim – bool Is the dimension kept in the reduced tensor? When True the dimension is kept, it is removed from the shape otherwise.

  Returns:

    The tensor produced by this reduction operation.

tensorrt_llm.functional.minimum(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.MIN: 3>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.mul(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.PROD: 1>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.non_gated_version(activation)

  Given an activation function, get the non-gated version.

  If the activation function is non-gated, it returns the same activation function name.

  For example, that function returns ‘silu’ for ‘swiglu’ and ‘relu’ for ‘relu’.

  Parameters:

    activation – str The name of the activation function.

  Returns:

    The name of the non-gated activation function.

tensorrt_llm.functional.op_and(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.AND: 8>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.op_or(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.OR: 9>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.outer(input: Tensor, vec2: Tensor ) → Tensor

  Add an operation to compute the outer product between two tensors.

  That operation creates an Einsum node.

  Parameters:

    - input – Tensor The first input tensor.

    - vec2 – Tensor The second input tensor.

  Returns:

    The output tensor produced by this layer.

tensorrt_llm.functional.permute(input: Tensor, dims: Sequence[int]) → Tensor

  Add an operation to permute the dimensions of a tensor.

  The dimensions of the input tensor are permutted according to the sequence of dimensions in ‘dims’. That operation maps to tensorrt.IShuffleLayer where the second transposition is described by the indices in ‘dims’.

  Given a tensor of rank N, the result of the permutation is a tensor of rank N in which the i-th input dimension maps to the dims[i]-th dimension.

  For example, permute(input, [1, 0]) will transpose a 2D tensor by permuting the rows and columns.

  Parameters:

    - input – Tensor The input tensor to permute.

    - dims – Sequence[int] The description of the permutation.

  Returns:

    The tensor produced by the permutation layer.

tensorrt_llm.functional.pow(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.POW: 6>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.recv(tensor: Tensor, src: int) → Tensor

  Add an operation that performs a recv to a rank from another.

  The recv operation receives a tensor from on a rank from another. If a rank ‘i’ receives a tensor from a rank ‘j’, the rank ‘j’ must have a corresponding ‘send’ operation to rank ‘j’. See ‘send’.

  That operation is implemented using a plugin that wraps the NCCL recv point-to-point operation. See https://docs.nvidia.com/deeplearning/nccl/user-guide/docs/api/p2p.html#ncclrecv for details.

  Parameters:

    - tensor – Tensor The input tensor.

    - src – int The rank that sends the tensor to.

  Returns:

    The tensor produced by that layer.

tensorrt_llm.functional.relu(input: ~tensorrt_llm.functional.Tensor, *, act_type: ~tensorrt.tensorrt.ActivationType = <ActivationType.RELU: 0>) → Tensor

  Add an activation function.

  Parameters:

    - input – Tensor The input tensor on which the activation function is applied.

    - act_type – trt.ActivationType The type of the activation (RELU, TANH, SIGMOID, …).

  The following closures are defined in functional.*:

  > relu for op=trt.ActivationType.RELU tanh for op=trt.ActivationType.TANH sigmoid for op=trt.ActivationType.SIGMOID

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.repeat_interleave(tensor: Tensor, repeats: int, dim: int) → Tensor

  Repeats elements of a tensor along an axis.

  Parameters:

    - repeats – int The number of repetitions along axis specified.

    - dim – int The dimension along which repetitions are performed.

  Returns:

    A tensor with the same shape as input except for repeated elements along specified dim.

  TODO: Allow repeats to be a list of integers and dim to be unspecified.

tensorrt_llm.functional.rms_norm(input: Tensor, normalized_shape: int | Tuple[int], weight: Tensor | None = None, eps: float = 1e-06) → Tensor

  Add a RMS norm operation on a tensor.

  That operation applies the rms-normalization to its input tensor. In its simplest form, for large language models, the ‘normalized_shape’ should be set to the hidden dimension of the activation tensor. Otherwise, it is the shape of the normalized fraction of the tensor (starting from the right-most dimension).

  The ‘weight’ tensor corresponds to ‘gamma’ in the rms-norm formula. The ‘eps’ value is added to the variance before computing the squared-root.

  Parameters:

    - input – Tensor The tensor to normalize.

    - normalized_shape – Union[int, Tuple[int]] The shape of the sub-tensor that is normalized. Use ‘hidden_dim’ to normalize the inner-most dimension of an activation tensor in LLMs.

    - weight – Optional[Tensor] = None The ‘gamma’ term in layer-norm. Its shape must be ‘normalized_shape’.

    - eps – float The epsilon term to be added to the variance in the squared-root.weig

  Returns:

    The output tensor of that operation.

tensorrt_llm.functional.round(input: ~tensorrt_llm.functional.Tensor, *, op: ~tensorrt.tensorrt.UnaryOperation = <UnaryOperation.ROUND: 22>) → Tensor

  Add an elementwise operation on a single input.

  The following closures are defined in functional.*:

  > round for op=trt.UnaryOperation.ROUND sqrt for op=trt.UnaryOperation.SQRT exp for op=trt.UnaryOperation.EXP sin for op=trt.UnaryOperation.SIN cos for op=trt.UnaryOperation.COS abs for op=trt.UnaryOperation.ABS

  It is implemented using the IUnaryLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - op – trt.UnaryOperation The unary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.select(input: Tensor, dim: int, index: Tensor | int) → Tensor

  Add an operation to select a slice of elements from a tensor.

  Given an input tensor, that function creates an operation that selects the index-th slice of elements in the dimension ‘dim’ to create a new tensor. The output tensor has a shape in which the input dimension ‘dim’ is removed.

  The ‘index’ can either be an integer or a 1D tensor containing a single element.

  For example, on input=[[4, 2, 5], [2, 1, 2], [4, 7, 1]], which has a shape [3, 3],

  > select(input, 0, 1)

  will create a tensor of shape [3] that contains the [2, 1, 2].

  Regarding the shape of the output tensor, the dimension ‘dim’ is removed. It means that for a tensor of shape [4, 2, 6, 3],

  > select(input, 2, 4)

  will select the 5th slice (index == 4) from the 3rd dimension (dim == 2) and return a tensor of shape [4, 2, 3] (i.e. the 3rd dimension is removed).

  That operation maps to the TensorRT IGatherLayer.

  Parameters:

    - input – Tensor The input tensor to select from.

    - dim – int The dimension to select from.

    - index – Union[Tensor, int] The index of the slice in the ‘dim’ dimension to select.

  Returns:

    The tensor containing the selected slice.

tensorrt_llm.functional.send(tensor: Tensor, tgt: int) → Tensor

  Add an operation that performs a send from a rank to another.

  The send operation sends a tensor from one rank to another. If a rank ‘i’ sends a tensor to a rank ‘j’, the rank ‘j’ must have a corresponding ‘recv’ operation from rank ‘i’. See ‘recv’.

  That operation is implemented using a plugin that wraps the NCCL send point-to-point operation. See https://docs.nvidia.com/deeplearning/nccl/user-guide/docs/api/p2p.html#ncclsend for details.

  Parameters:

    - tensor – Tensor The input tensor.

    - tgt – int The rank that receives the tensor.

  Returns:

    The tensor produced by that layer.

tensorrt_llm.functional.shape(input: Tensor, dim: int | None = None) → Tensor

  Add an operation to create a shape tensor.

  The shape tensor can either be the shape of the input tensor when the parameter dim is None or a scalar (tensor of rank 0) that corresponds to the size of dim-th dimension.

  Parameters:

    - input – Tensor The input tensor from which we want to extract the shape or the size in one dimension.

    - dim – Optional[int] The dimension from which to extract the size. If it is None, the entire shape of the input tensor is returned.

  Returns:

    A tensor that contains the shape of the input tensor (if ‘dim’ is None) or the size in the dimension ‘dim’ of the input tensor. If ‘dim’ is ‘None’, that tensor has the same rank as the input tensor, otherwise its rank is 0.

tensorrt_llm.functional.sigmoid(input: ~tensorrt_llm.functional.Tensor, *, act_type: ~tensorrt.tensorrt.ActivationType = <ActivationType.SIGMOID: 1>) → Tensor

  Add an activation function.

  Parameters:

    - input – Tensor The input tensor on which the activation function is applied.

    - act_type – trt.ActivationType The type of the activation (RELU, TANH, SIGMOID, …).

  The following closures are defined in functional.*:

  > relu for op=trt.ActivationType.RELU tanh for op=trt.ActivationType.TANH sigmoid for op=trt.ActivationType.SIGMOID

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.silu(input: Tensor ) → Tensor

  Add a SiLU (x * sigmoid(x)) operation.

  Parameters:

    input – Tensor The input tensor on which the activation function is applied.

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.sin(input: ~tensorrt_llm.functional.Tensor, *, op: ~tensorrt.tensorrt.UnaryOperation = <UnaryOperation.SIN: 6>) → Tensor

  Add an elementwise operation on a single input.

  The following closures are defined in functional.*:

  > round for op=trt.UnaryOperation.ROUND sqrt for op=trt.UnaryOperation.SQRT exp for op=trt.UnaryOperation.EXP sin for op=trt.UnaryOperation.SIN cos for op=trt.UnaryOperation.COS abs for op=trt.UnaryOperation.ABS

  It is implemented using the IUnaryLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - op – trt.UnaryOperation The unary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.slice(input: Tensor, starts: Tensor | Sequence[int], sizes: Tensor | Sequence[int], strides: Tensor | Sequence[int] | None = None) → Tensor

  Add an operation to extract a slice from a tensor.

  As described in the TensorRT documentation of the ISliceLayer, the slice layer has two variants: Static and dynamic.

  For static slicing, this function takes the starts and sizes values in the different dimensions to slice at layer creation time via a sequence of integers. For dynamic slicing, it accepts starts and sizes as tensorrt.ITensor`s.

  The slice layer selects for each dimension a start location from within the input tensor, and copies elements to the output tensor using a stride of 1 across the input tensor. Start and size tensors must be 1-D int32 shape tensors if not specified as a sequence of integers.

  As an example, on input = [[0, 2, 4], [1, 3, 5]], the call to

  > slice(input, start=[1, 0], size=[1, 2])

  will produce the tensor [[1, 3]] as output. The slice operator when executed by TensorRT will copy one row (because size[0] == 1) starting from the 2nd row (because start[0] == 1) and two columns (size[1] == 2) starting from the 1st column (because start[1] == 0).

  In pseudo-code the behaviour of that operation can be described as follows for a 2D tensor (and easily be extended to more dimensions):

  > output = Tensor(shape=sizes) for ii in range(sizes[0]):

  > > for jj in range(sizes[1]):

  > >   output[ii][jj] = input[starts[0]+ii][starts[1]+jj]

  Note that it is common in deep-learning frameworks to use ranges [start:end] for similar operations. It can be emulated by setting the sizes argument such that in each dimension [start:start+size] == [start:end] i.e. size = end-start.

  TensorRT supports different slice modes but that function restricts that choice to mode == tensorrt.SliceMode.STRICT_BOUNDS.

  Parameters:

    - input – Tensor The input tensor on which the slicing is performed.

    - starts – Union[Tensor, Sequence[int]] The starting points, in the input tensor, and each dimension.

    - sizes – Union[Tensor, Sequence[int]] The number of elements in each dimension of the sliced tensor (output).

    - strides – Union[Tensor, Sequence[int]] The step be taken from start, in input tensor.

  Returns:

    The tensor produced by the slice layer.

tensorrt_llm.functional.softmax(input: Tensor, dim: int | None = None) → Tensor

  Add an operation to compute softmax on a tensor.

  That operation computes the softmax on the input tensor in the dimension ‘dim’ if specified. Otherwise, it is applied on the last dimension.

  It inserts a ISoftmaxLayer to the TensorRT graph.

  Parameters:

    - input – Tensor The input tensor on which to apply softmax.

    - dim – Optional[int] The dimension used to apply softmax.

  Returns:

    The output tensor of the softmax layer.

tensorrt_llm.functional.softplus(input: Tensor, beta: float, threshold: float) → Tensor

  Add the softplus activation base on PyTorch definition.

  See https://pytorch.org/docs/stable/generated/torch.nn.functional.softplus.html for a description of that function.

  Parameters:

    - input – Tensor Input TensorRT-LLM Tensor.

    - beta – float The parameter for softplus computation.

    - threshold – float The threshold for reverting to the linear function when input * beta > threshold

  Returns:

    The output tensor created by that layer.

tensorrt_llm.functional.split(tensor: Tensor, split_size_or_sections: int | Sequence[int], dim: int = 0) → Sequence[ Tensor ]

  Add an operation that splits a tensor into sub-tensors.

  This operation creates a list of tensors that are obtained from the input tensor by slicing it along the dimension ‘dim’. If ‘split_size_or_sections’ is an integer, the tensor is split into ‘input.shape[dim] / split_size_or_sections’ slices. If ‘split_size_or_sections’ is a list of sizes, the tensor is split into ‘len(split_size_or_sections)’ slices and the size of the ith slice is given by ‘split_size_or_sections[i]’.

  There are several constraints with the current implementation:

  > - The input tensor must be static (no dynamic dimension),

  > - If ‘split_size_or_sections’ is an integer, the number of elements in the ‘dim’ dimension of the input must be a multiple of ‘split_size_or_sections’: ‘input.shape[dim] % split_size_or_sections == 0’.

  > - If ‘split_size_or_sections’ is a sequence, the sum of the elements in ‘split_size_or_sections’ must be equal to the size in the dimension ‘dim’: ‘input.shape[dim] == sum(ii for ii in split_size_or_sections)’.

  That operation is implemented using a ‘slice’ operation for each output slice.

  Parameters:

    - tensor – Tensor The input tensor to slice.

    - split_size_or_sections – Union[int, Sequence[int]] If it is an integer, it encodes the size of each slice. Otherwise, if it is a sequence, it is the size of each slice.

    - dim – int The dimension of the tensor to slice.

  Returns:

    The list of tensors produced by the different operations.

tensorrt_llm.functional.sqrt(input: ~tensorrt_llm.functional.Tensor, *, op: ~tensorrt.tensorrt.UnaryOperation = <UnaryOperation.SQRT: 2>) → Tensor

  Add an elementwise operation on a single input.

  The following closures are defined in functional.*:

  > round for op=trt.UnaryOperation.ROUND sqrt for op=trt.UnaryOperation.SQRT exp for op=trt.UnaryOperation.EXP sin for op=trt.UnaryOperation.SIN cos for op=trt.UnaryOperation.COS abs for op=trt.UnaryOperation.ABS

  It is implemented using the IUnaryLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - op – trt.UnaryOperation The unary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.squared_relu(x: Tensor ) → Tensor

  Add a Squared ReLU operation.

  This function applies ReLU and squares the output.

  Parameters:

    input – Tensor The input tensor on which the activation function is applied.

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.sub(left: ~tensorrt_llm.functional.Tensor | int | float, right: ~tensorrt_llm.functional.Tensor | int | float, *, op: ~tensorrt.tensorrt.ElementWiseOperation = <ElementWiseOperation.SUB: 4>) → Tensor

  Add an elementwise operation with two inputs.

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the elementwise operation ‘op’.

  The following closures are defined in functional.*:

  > add for op=trt.ElementWiseOperation.SUM sub for op=trt.ElementWiseOperation.SUB mul for op=trt.ElementWiseOperation.PROD div for op=trt.ElementWiseOperation.DIV gt for op=trt.ElementWiseOperation.GREATER lt for op=trt.ElementWiseOperation.LESS op_and for op=trt.ElementWiseOperation.AND op_or for op=trt.ElementWiseOperation.OR eq for op=trt.ElementWiseOperation.EQUAL minimum for op=trt.ElementWiseOperation.MIN maximum for op=trt.ElementWiseOperation.MAX pow for op=trt.ElementWiseOperation.POW

  It is implemented using the IElementWiseLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.swiglu(input: Tensor ) → Tensor

  Add a SwiGLU (x * SiLU(gate)) operation.

  That function takes a tensor, splits it into two halves along the last dimension, applies SiLU to the second half and multiply the results. The behaviour is undefined if the last dimension is not even.

  Parameters:

    input – Tensor The input tensor on which the activation function is applied.

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.tanh(input: ~tensorrt_llm.functional.Tensor, *, act_type: ~tensorrt.tensorrt.ActivationType = <ActivationType.TANH: 2>) → Tensor

  Add an activation function.

  Parameters:

    - input – Tensor The input tensor on which the activation function is applied.

    - act_type – trt.ActivationType The type of the activation (RELU, TANH, SIGMOID, …).

  The following closures are defined in functional.*:

  > relu for op=trt.ActivationType.RELU tanh for op=trt.ActivationType.TANH sigmoid for op=trt.ActivationType.SIGMOID

  Returns:

    The tensor produced by the activation layer.

tensorrt_llm.functional.transpose(input: Tensor, dim0: int, dim1: int) → Tensor

  Add an operation to transpose two dimensions of a tensor.

  That operation produces a tensor in which the dimensions ‘dim0’ and ‘dim1’ are permuted. The other dimensions, if the rank of the tensor is greater than 2, remain untouched.

  That function is a helper built on the ‘functional.permute’ function.

  Parameters:

    - input – Tensor The input tensor to transpose.

    - dim0 – int The first dimension to transpose.

    - dim1 – int The second dimension to transpose.

  Returns:

    The tensor produced by the permutation layer.

tensorrt_llm.functional.unary(input: Tensor, op: UnaryOperation) → Tensor

  Add an elementwise operation on a single input.

  The following closures are defined in functional.*:

  > round for op=trt.UnaryOperation.ROUND sqrt for op=trt.UnaryOperation.SQRT exp for op=trt.UnaryOperation.EXP sin for op=trt.UnaryOperation.SIN cos for op=trt.UnaryOperation.COS abs for op=trt.UnaryOperation.ABS

  It is implemented using the IUnaryLayer from TensorRT.

  Parameters:

    - input – Tensor The input tensor.

    - op – trt.UnaryOperation The unary operation to perform.

  Returns:

    The tensor produced by this elementwise operation.

tensorrt_llm.functional.unsqueeze(input: Tensor, axis: int)

  Add an operation to insert a singleton dimension to a tensor.

  That functions creates an operation that insert a singleton dimension (dimension of size 1) at position ‘dim’ in the output tensor. It works with negative values for the ‘axis’.

  For example, for a tensor ‘input’ of shape [4, 4]:

  > unsqueeze(input, 0) will produce an output of shape [1, 4, 4], unsqueeze(input, 1) will produce an output of shape [4, 1, 4], unsqueeze(input, -1) will produce an output of shape [4, 4, 1], unsqueeze(input, -2) will produce an output of shape [4, 1, 4],

  Parameters:

    - input – Tensor The input tensor to expand with a singleton dimension.

    - axis – int The index of the singleton dimension in the output tensor.

  Returns:

    The tensor produced by the layer.

tensorrt_llm.functional.view(input: Tensor, shape: Tensor | Sequence[int], zero_is_placeholder: bool = True) → Tensor

  Add an operation to create a view of a tensor.

  That operation adds a tensorrt.IShuffleLayer to the network. If the ‘shape’ parameter is a Tensor, that view is dynamic. Otherwise, it is a static view.

  Note that TensorRT limits the number of inferred dimensions to 1. It means that the shape sequence or tensor cannot contain more than one -1. This function enforces that constraint and will assert if it is not respected.

  Parameters:

    - input – Tensor The input tensor to transpose.

    - shape – Union[Tensor, Sequence[int]] The shape of the new tensor.

    - zero_is_placeholder – bool When that parameter is True, the 0s in ‘shape’ are replaced by the sizes of the corresponding dimensions from the ‘input’. Otherwise, the dimensions corresponding to 0s are shrunk.

  Returns:

    The tensor produced by the view/shuffle layer.

tensorrt_llm.functional.where(condition: Tensor | int | float, left: Tensor | int | float, right: Tensor | int | float) → Tensor

  Add a where (aka select or if-then-else) operation.

  Assuming the three input parameters have the same shape, that function creates the operation to compute a tensor of the same shape such that:

  > for ii in range(mul(condition.shape)):

  >   output[ii] = left[ii] if condition[ii] else right[ii]

  For each input, that function first creates a constant tensor if the input is an integer or a float. Then, if needed, it expands the smaller tensor to make sure its rank is the same as the larger one. Then, it performs the selection.

  It is implemented using the ISelectLayer from TensorRT.

  Parameters:

    - left – Union[Tensor, int, float] The condition. If that input is an integer or a float, the function creates a constant tensor.

    - left – Union[Tensor, int, float] The first input. If that input is an integer or a float, the function creates a constant tensor.

    - right – Union[Tensor, int, float] The second input. If that input is an integer or a float, the function creates a constant tensor.

    - op – trt.ElementWiseOperation The binary operation to perform.

  Returns:

    The tensor produced by this select operation.